%define kr_doc_version	2.6
%define _unpackaged_files_terminate_build 0

Summary:	Professional FTP daemon
Name:		proftpd
Version:	1.3.3g
Release:	1%{?dist}
Epoch:		1
License:	GPL
Group:		System Environment/Daemons
URL:		http://proftpd.oops.org/
Source0:	ftp://ftp.proftpd.org/distrib/source/%{name}-%{version}.tar.bz2
Source1:	korean_docs-%{kr_doc_version}.tgz
Source2:	ftpusers
Source3:	welcome.msg
Source4:	xinetd.sample
Source5:	proftpd.init.d
Source6:	proftpd.logrotate
Source7:	proftpd.pam
Source9:	proftpd-config.tar.bz2
Source10:	proftpd-util-ko.po
Source11:	proftpd.cron

Source50:	mod_anontype-0.1.tar.bz2
Source51:	mod_sticky-0.1.tar.bz2
Source52:	mod_timelimit-0.1.tar.bz2

Patch0:		proftpd-pamlib.patch
Patch1:		proftpd-humanreadable.patch
Patch2:		proftpd-version.patch
Patch3:		proftpd-xfer-kr.patch
Patch4:		proftpd-util-gettext.patch
Patch5:		proftpd-krtime.patch
Patch6:		proftpd-sendfile-scoreboard.patch
Patch7:		proftpd-rundir.patch

# bug fix
#Patch100:	proftpd-1.3.3c-bug3531.patch

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Provides:	ftpserver
BuildRequires: tcp_wrappers-devel, pam-devel
Requires:	pam >= 0.74 chkconfig, tcp_wrappers-libs
Conflicts:	wu-ftpd ncftpd beroftpd anonftp vsftpd

%description
ProFTPD is a highly configurable FTP daemon for UNIX and UNIX-like
operating systems.  ProFTPD features virtual hosting, default root
directories, and a completely new (not based on other implementations)
source tree.

%description -l ko
ProFTPD는 Unix또는 Unix 호환 시스템을 위한 강력한 FTP daemon 이며, 다중 
가상 호스트, 기본 root direcctory 그리고 완벽하게 새로운 소스 구조의
요소를 포함하고 있다.

%package devel
Summary: ProFTPd Header file
Summary(ko): ProFTPd 헤더 파일
Group: Development

%description devel
This package includes proftpd header file for ProFTPd module build

%description devel -l ko
이 패키지는 ProFTPd 모듈 빌드를 위한 헤더 파일들을 가지고 있다.

%package standalone
Summary: ProFTPd Standalone init script
Summary(ko): ProFTPd Standalone 구동 스크립트
Group:System Environment/Daemons
Conflicts: %{name}-inetd
Requires: %{name} = %{epoch}:%{version}-%{release}

%description standalone
This package includes proftpd standalone init script.

%description standalone -l ko
이 패키지는 ProFTPd standalone 방식의 구동 스크립트를 포함하고 있다.

%package xinetd
Summary: ProFTPd Standalone init script
Summary(ko): ProFTPd xinetd configuration
Group:System Environment/Daemons
Conflicts: %{name}-standalone
Requires: %{name} = %{epoch}:%{version}-%{release}, xinetd

%description xinetd
This package includes xinetd configuration of proftpd

%description xinetd -l ko
이 패키지는 ProFTPd xinetd 구동 설정 파일을 포함하고 있다.

%package doc
Summary: ProFTPd Documents
Summary(ko): ProFTPd 문서 꾸러미
Group: Documentation

%description doc
This package includes proftpd documents, korean documents, and sample
configuration files. korean documents made by proftpd korean user group.

%description doc -l ko
이 패키지는 proftpd 문서들과, 한글 번역 문서, 그리고 샘플 설정 파일이
포함이 되어 있다. 한글 번역 문서는 proftpd korean user group 의 번역 작
업에 의해 포함이 되어졌다.

%prep
%setup -q -n %{name}-%{version} -a 50 -a 51 -a 52
for i in anontype sticky timelimit
do
	%{__install} -m644 mod_${i}/mod_*.c contrib/
done

%{__install} %{SOURCE10} locale/ko_KR-util.po

# official bug fix
#patch100 -p1
#patch101 -p1
#patch102 -p1

%patch0 -p1 -b .rpm_pamlib
%patch1 -p1 -b .rpm_human
%patch2 -p1 -b .rpm_version
# xferstats korean patch
%patch3 -p1 -b .kr
%patch4 -p1 -b .gettext
%patch5 -p1 -b .krtime
%patch6 -p1
%patch7 -p1

%{__tar} xvfz %{SOURCE1}

find . -type d -exec chmod 755 {} \;

%build
CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s \
./configure --prefix=%{_prefix} \
			--sysconfdir=%{_sysconfdir}/proftpd \
			--libexecdir=%{_libdir}/proftpd \
			--mandir=%{_mandir} \
			--localstatedir=%{_localstatedir}/run \
			--enable-dso \
			--enable-autoshadow \
			--enable-auth-pam \
			--enable-nls \
			--enable-cap \
			--enable-ctrls \
			--enable-facl \
			--enable-openssl \
			--enable-sendfile \
			--enable-ipv6 \
			--enable-buffer-size=8192 \
			--enable-pool-size=4096 \
			--with-shared=mod_ratio:mod_readme:mod_wrap:mod_tls:mod_ctrls_admin:mod_ifsession:mod_quotatab:mod_rewrite:mod_site_misc:mod_ban:mod_unique_id:mod_anontype:mod_sticky:mod_timelimit

%{__make} %{?_smp_mflags}

%install
if [ ! -d %{buildroot} ] ; then
	%{__mkdir_p} %{buildroot}
fi

%{__make} DESTDIR=%{buildroot} install

[ ! -d %{buildroot}%{_localstatedir}/run/proftpd ] &&
	%{__mkdir_p} %{buildroot}%{_localstatedir}/run/proftpd

( cd %{buildroot}%{_sbindir}
  %{__ln_s} -f proftpd in.proftpd
  %{__ln_s} -f proftpd in.ftpd)

%{__install} -m 755 contrib/xferstats.holger-preiss \
        %{buildroot}%{_sbindir}/xferstats
%{__install} -m 755 contrib/ftpasswd  %{buildroot}%{_bindir}/ftpasswd

%{__mkdir_p} %{buildroot}%{_sysconfdir}/{pam.d,logrotate.d}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xinetd.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__mkdir_p} %{buildroot}%{_mandir}/ko/{man1,man8}
#{__mkdir_p} %{buildroot}%{_mandir}/{man1,man5,man8}
%{__mkdir_p} $RPM_BUILD_DIR/proftpd-%{version}/init_script

#{__install} -m 644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/proftpd
%{__install} -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/pam.d/proftpd
pushd %{buildroot}%{_sysconfdir}/pam.d/
%{__ln_s} -f proftpd ftp
popd

%{__install} -m 600 %{SOURCE2} %{buildroot}%{_sysconfdir}/proftpd/ftpusers
%{__install} -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/proftpd/welcome.msg
%{__install} -m 755 %{SOURCE5} %{buildroot}%{_sysconfdir}/rc.d/init.d/proftpd
#{__install} -m 755 %{SOURCE5} $RPM_BUILD_DIR/proftpd-%{version}/proftpd-standalone.init
#{__install} -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/xinetd.d/proftpd-inetd
%{__install} -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/xinetd.d/proftpd
%{__install} -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/proftpd

%{__ln_s} -f /usr/share/doc/proftpd-doc-%{version} %{buildroot}%{_sysconfdir}/proftpd/document

# remove english config file - by oops
%{__rm} -rf %{buildroot}%{_sysconfdir}/proftpd/conf

pushd %{buildroot}%{_sysconfdir}/proftpd
tar xvfpj %{SOURCE9}
chown -R root.root *
popd

%{__mkdir_p} %{buildroot}%{_sysconfdir}/cron.d/
%{__install} -m 644 %{SOURCE11} \
	%{buildroot}%{_sysconfdir}/cron.d/proftpd

%{__perl} -pi -e "s!#libdir#!%{_libdir}!g" \
	%{buildroot}%{_sysconfdir}/proftpd/module.d/Load.conf

# install man page
#{__install} -m 644 src/ftpcount.1 %{buildroot}%{_mandir}/man1/ftpcount.1
#{__install} -m 644 src/ftpwho.1 %{buildroot}%{_mandir}/man1/ftpwho.1
#{__install} -m 644 src/xferlog.5 %{buildroot}%{_mandir}/man1/xferlog.5
#{__install} -m 644 src/ftpshut.8 %{buildroot}%{_mandir}/man1/ftpshut.8
#{__install} -m 644 src/proftpd.8 %{buildroot}%{_mandir}/man1/proftpd.8

# install korean man page
%{__install} -m 644 korean_docs-%{kr_doc_version}/Man/*.1 \
               %{buildroot}%{_mandir}/ko/man1/
%{__install} -m 644 korean_docs-%{kr_doc_version}/Man/*.8 \
               %{buildroot}%{_mandir}/ko/man8/

%{__rm} -rf korean_docs-%{kr_doc_version}/Man

mv %{buildroot}%{_bindir}/prxs %{buildroot}%{_sbindir}/prxs

#msgfmt %{SOURCE10} -o proftpd-util.mo
#{__install} -m 644 proftpd-util.mo %{buildroot}%{_datadir}/locale/ko_KR/LC_MESSAGES/

%ifarch x86_64
	%{__mv} %{buildroot}/usr/lib/pkgconfig %{buildroot}/usr/lib64/pkgconfig
%endif

%post standalone
if [ $1 = 1 ]; then
  /sbin/chkconfig --add proftpd
  /sbin/chkconfig --level 35 proftpd on
  if [ -f "%{_localstatedir}/run/proftpd/proftpd.scoreboard" ]; then
    rm -f %{_localstatedir}/run/proftpd/proftpd.scoreboard
  fi
fi

%post xinetd
if [ $1 = 1 ]; then
  if [ -f "%{_localstatedir}/run/proftpd/proftpd.scoreboard" ]; then
    rm -f %{_localstatedir}/run/proftpd/proftpd.scoreboard
  fi

  if [ -f "/sbin/chkconfig" ]; then
    /sbin/chkconfig proftpd off &> /dev/null
    /sbin/chkconfig proftpd on &> /dev/null
  fi
fi

%preun standalone
if [ $1 = 0 ]; then
	/sbin/service proftpd stop
	/sbin/chkconfig --del proftpd
fi

%preun xinetd
if [ $1 = 0 ]; then
	/sbin/chkconfig proftpd off &> /dev/null
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%dir %{_sysconfdir}/proftpd/
%dir %{_sysconfdir}/proftpd/module.d
%dir %{_sysconfdir}/proftpd/user.d
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/proftpd/proftpd.conf
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/proftpd/module.d/*.conf
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/proftpd/user.d/*.conf
%config(noreplace) %{_sysconfdir}/proftpd/welcome.msg
%config(noreplace) %{_sysconfdir}/proftpd/ftpusers
%config %{_sysconfdir}/pam.d/proftpd
%{_sysconfdir}/pam.d/ftp
%config %{_sysconfdir}/logrotate.d/proftpd
%attr(511,root,root)%{_sbindir}/proftpd
%attr(-,root,root)%{_sbindir}/in.proftpd
%attr(-,root,root)%{_sbindir}/in.ftpd
%attr(-,root,root)%{_sbindir}/ftpscrub
%attr(755,root,root)%{_sbindir}/ftpshut
%attr(755,root,root)%{_sbindir}/xferstats
%attr(755,root,root)%{_bindir}/ftpcount
%attr(755,root,root)%{_bindir}/ftptop
%attr(755,root,root)%{_bindir}/ftpwho
%attr(755,root,root)%{_bindir}/ftpasswd
%attr(755,root,root)%{_bindir}/ftpdctl
%attr(755,root,root) %dir %{_localstatedir}/run/proftpd
%attr(-,root,man) %{_mandir}/man*/*
%attr(-,root,man) %{_mandir}/ko/man*/*

%dir %{_libdir}/proftpd
%{_libdir}/proftpd/*.so
%{_libdir}/proftpd/*.la
%{_datadir}/locale/*/LC_MESSAGES/*.mo

%files standalone
%defattr(-,root,root)
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/proftpd
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/proftpd/server.d/standalone.conf
%dir %{_sysconfdir}/proftpd/server.d

%files xinetd
%defattr(-,root,root)
%attr(644,root,root) %{_sysconfdir}/xinetd.d/proftpd
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/proftpd/server.d/inetd.conf
%config(noreplace) %{_sysconfdir}/cron.d/proftpd
%dir %{_sysconfdir}/proftpd/server.d

%files devel
%defattr(-,root,root)
%{_sbindir}/prxs
%{_includedir}/proftpd/*
%{_libdir}/proftpd/*.a
%{_libdir}/pkgconfig/*.pc

%files doc
%defattr(-,root,root)
%doc COPYING INSTALL README README.Solaris2.5x README.PAM
%doc ChangeLog contrib korean_docs-%{kr_doc_version}
%doc sample-configurations/virtual.conf
%doc sample-configurations/anonymous.conf
%doc sample-configurations/complex-virtual.conf
%doc %{_sysconfdir}/proftpd/document
%doc doc/Configuration.html
%doc doc/Configuration.sgml
%doc doc/faq.html
%doc doc/license.txt
%doc doc/rfc/*

%changelog
* Fri Jan 26 2012 JoungKyun.Kim <http://oops.org> 1:1.3.3g-1%{?dist}
- update 1.3.3g

